attribute mediump vec4 a_position;
attribute mediump vec2 a_texCoord0;
attribute lowp vec4 a_color;

uniform mat4 u_modelViewProjection;

varying mediump vec2 v_texCoord;
varying lowp vec4 v_color;

void main()
{
	v_color = a_color;
	v_texCoord = a_texCoord0;
	gl_Position = u_modelViewProjection * a_position;
}

